Diff view for .js files in repositories is broken

2019-11-11 15:54 - terrell smith

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Go MAEDA % Done: 0%

Category: SCM Estimated time: 0.00 hour

Target version: 4.0.7   

Resolution: Fixed Affected version: 4.0.5

Description

When viewing a commit in the repository for a non-javascript file, clicking the diff link for that file opens the diff in the "view

differences" tab on the same page.

When viewing a javascript file with a .js extension, clicking the diff link opens the snippet that would normally go in the "view

differences" as a new page with no styling.

This is happening on our install across projects and consistently for all javascript files. Clicking on the "view differences" table for the

javascript files instead of the diff link does display normally. It is easy to work around, by just using the show differences tab instead

of the diff link.

Environment:

Redmine version                4.0.5.stable

Ruby version                   2.6.3-p62 (2019-04-16) [x86_64-linux]

Rails version                  5.2.3

Environment                    production

Database adapter               Mysql2

Mailer queue                   ActiveJob::QueueAdapters::AsyncAdapter

Mailer delivery                smtp

SCM:

Git                            2.17.1

Related issues:

Related to Redmine - Defect #30850: Unified diff link broken on specific file... Closed

Related to Redmine - Defect #37626: Diff of a javascript file in repository m... Closed

Associated revisions

Revision 19531 - 2020-02-27 02:19 - Go MAEDA

Diff view for .js files in repositories is broken (#32449).

Patch by Mizuki ISHIKAWA.

Revision 19532 - 2020-02-27 02:21 - Go MAEDA

Merged r19531 from trunk to 4.1-stable (#32449).

Revision 19533 - 2020-02-27 02:22 - Go MAEDA

Merged r19531 from trunk to 4.0-stable (#32449).

History

#1 - 2020-02-13 12:02 - Samuel Monsarrat

We have the same problem with a GIT or SVN backend.

It looks like the page rendering crashes while building a DIFF of a Javascript file (something to do with syntax highlighting?).

All other file types seem ok:

Example :

https://source.scenari.software/projects/dev-core/repository/git/revisions/300fb80a966ae09c1ac7c8f7a8104a31dde93b72

The simple view of the Javascript file is ok :

https://source.scenari.software/projects/dev-core/repository/git/revisions/300fb80a966ae09c1ac7c8f7a8104a31dde93b72/entry/Wsp_Modeling/space

s/gen/modelBuilder/bs/_common/sm/webSiteGenerator/scDynUiMgr.js
But the diff view is not :

https://source.scenari.software/projects/dev-core/repository/git/revisions/300fb80a966ae09c1ac7c8f7a8104a31dde93b72/diff/Wsp_Modeling/spaces/

gen/modelBuilder/bs/_common/sm/webSiteGenerator/scDynUiMgr.js

#2 - 2020-02-19 09:57 - Go MAEDA

- Status changed from New to Confirmed

#3 - 2020-02-19 10:36 - Guillermo ML

- File defect.32449-redmine_3.4.4.png added

- File defect.32449-redmine_4.0.4.png added

Same with our Mercurial SCM.

version 3.4.4.stable --> works fine

 defect.32449-redmine_3.4.4.png 

version 4.0.4.stable --> no styles and the menu disappears

 defect.32449-redmine_4.0.4.png 

#4 - 2020-02-21 03:44 - Mizuki ISHIKAWA

When displaying the js file, base.html.erb was not used as the layout file.

Specifying an explicit layout file as shown below should solve the problem.

diff --git a/app/controllers/repositories_controller.rb b/app/controllers/repositories_controller.rb

index 269bc70a0..8350b4d48 100644

--- a/app/controllers/repositories_controller.rb

+++ b/app/controllers/repositories_controller.rb

@@ -269,7 +269,7 @@ class RepositoriesController < ApplicationController

       @changeset = @repository.find_changeset_by_name(@rev)

       @changeset_to = @rev_to ? @repository.find_changeset_by_name(@rev_to) : nil

       @diff_format_revisions = @repository.diff_format_revisions(@changeset, @changeset_to)

-      render :diff, :formats => :html

+      render :diff, :formats => :html, :layout => 'base.html.erb'

     end

   end

#5 - 2020-02-21 06:08 - Go MAEDA

- Related to Defect #30850: Unified diff link broken on specific file/revision diff view added

#6 - 2020-02-21 09:11 - Guillermo ML

After applying Mizuki ISHIKAWA's change and restarting Redmine, View differences page works flawlessly with .js files.

#7 - 2020-02-21 14:43 - Go MAEDA

- Target version set to 4.0.7

Setting the target version to 4.0.7.

#8 - 2020-02-24 03:43 - Go MAEDA

- Subject changed from diff display issue for js files in git to Diff view for .js files in repositories is broken

#9 - 2020-02-27 02:22 - Go MAEDA

- Status changed from Confirmed to Closed

- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the patch. Thank you all for reporting and fixing this issue.

#10 - 2022-09-01 08:53 - Go MAEDA

- Related to Defect #37626: Diff of a javascript file in repository module is not displayed with layout  added
